function addCMSEvent( obj, type, fn ) {
  if ( obj.attachEvent ) {
	obj['e'+type+fn] = fn;
	obj[type+fn] = function(){obj['e'+type+fn]( window.event );}
	obj.attachEvent( 'on'+type, obj[type+fn] );
  } else
	obj.addEventListener( type, fn, false );
}
function removeCMSEvent( obj, type, fn ) {
  if ( obj.detachEvent ) {
	obj.detachEvent( 'on'+type, obj[type+fn] );
	obj[type+fn] = null;
  } else
	obj.removeEventListener( type, fn, false );
}
var editor_resize_timer = false;
if (window.CKEDITOR) CKEDITOR.on( 'instanceCreated', function( event ) {
  var editor = event.editor,
  element = editor.element;
  var contentID = false;
  var contentToolbar = false;
  if (element.getParent()) {
	  contentID = element.getParent();
	  contentToolbar = contentID.getAttribute("toolbar");
  }
  if (contentID) contentID = contentID.getAttribute("id");
  
  if (editor.name == "cms-editor") {
	editor.on( 'resize', function() {
		if (editor_resize_timer) clearTimeout(editor_resize_timer);
		editor_resize_timer = setTimeout("positionCMSOverlay();",300);
	});
  }
  
  if (contentID && contentID.indexOf("cms-content-") == 0) {
	var toolbar = pcms_toolbars[contentToolbar];
	if (!toolbar) toolbar = pcms_toolbars["inline default"];
	editor.config.toolbar = toolbar;
	editor.on( 'blur', function() {
		if (this.checkDirty()) {
		  if (confirm("Save Changes?")) {
			 this.resetDirty();
			 var contentID = (element.getParent().getAttribute("id"));
			 contentID = contentID.substring(contentID.lastIndexOf("-")+1);
			 ajax_update_cms(contentID,this.getData());
		  } else {
			 this.setData(this.oldEditorData);
		  }
		}
	});
	
	editor.on( 'focus', function() {
		this.resetDirty();
		this.oldEditorData = this.getData();
	});
  }
});

function ajax_update_cms(id,content,seo)  {
  var xmlHttp;
  try
  {
  xmlHttp=new XMLHttpRequest();
  }
  catch (e)
  {
  try
    {
    xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
    }
  catch (e)
    {
    try
      {
      xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
      }
    catch (e)
      {
      return false;
      }
    }
  }
  var getparams = "";
  if (seo) {
	var postparams = "";
	for (var x=0; x<id.length; x++) {
	  if (postparams != "") postparams += "&";
	  postparams += "id[]="+id[x];
	  postparams += "&";
	  postparams += "content[]="+content[x];
	}
  } else {
    var postparams = "content=" + escape(content) +"&id=" + id;
  }
  var postmethod = "POST";
  xmlHttp.open("POST", cms_root + "/admin_cms/inline_edit.php" ,true);
  xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttp.send(postparams);
}

addCMSEvent(window,'load', function() {
  SetCMSOverlays();
});

addCMSEvent(window,'resize', function() {
  if (document.getElementById('overlay-cms-content') && document.getElementById('overlay-cms-content').style.display == "block") positionCMSOverlay();
  if (document.getElementById('overlay-cms-seo') && document.getElementById('overlay-cms-content').style.display == "block") positionSEOOverlay();
});

function positionCMSOverlay() {
  //adjust popup
  var overlay_size = document.getElementById('overlay-cms-content').offsetHeight;
  var window_size = window.innerHeight;
  var window_top = ((window_size -overlay_size)/2);
  if (window_top < 0) window_top = 0;
  document.getElementById('overlay-cms-content').style.top = window_top + 'px';
}
function showSEOOverlay() {
	document.getElementById('overlay-bg').style.display = "block";
	document.getElementById('overlay-cms-seo').style.display = "block";	
	positionSEOOverlay()
}
function positionSEOOverlay() {
  //adjust popup
  var overlay_size = document.getElementById('overlay-cms-seo').offsetHeight;
  var window_size = window.innerHeight;
  var window_top = ((window_size -overlay_size)/2);
  if (window_top < 0) window_top = 0;
  document.getElementById('overlay-cms-seo').style.top = window_top + 'px';
}

function SetCMSOverlays() {
  var fileref = document.createElement("link");
  fileref.setAttribute("rel", "stylesheet");
  fileref.setAttribute("type", "text/css");
  fileref.setAttribute("href", cms_root + "/WA_CMS/WA_CMS.css");
                
  document.getElementsByTagName("head")[0].appendChild(fileref);
	
  var bgoverlay = document.createElement("div");
  bgoverlay.setAttribute("id","overlay-bg");
  document.body.appendChild(bgoverlay);
  
  var editoverlay = document.createElement("div");
  editoverlay.setAttribute("id","overlay-cms-content");
  editoverlay.setAttribute("class","overlay-cms");
  editoverlay.setAttribute("style","display:none");
  
  var h4obj = document.createElement("h4");
  var h4text = document.createTextNode("Update your content");
  h4obj.appendChild(h4text);
  
  var pobj = document.createElement("p");
  var ptext = document.createTextNode("Update your content and see it reflected immediately on the page once you save. Pretty neat huh?");
  pobj.appendChild(ptext);
  
  var textareaobj = document.createElement("textarea");
  textareaobj.setAttribute("id","cms-editor");
  textareaobj.setAttribute("name","cms-editor");
  
  var hiddenobj = document.createElement("input");
  hiddenobj.setAttribute("type","hidden");
  hiddenobj.setAttribute("name","cms-content-id");
  hiddenobj.setAttribute("id","cms-content-id");
  
  var buttondiv = document.createElement("div");
  buttondiv.setAttribute("class","buttons");
  
  var savebtn = document.createElement("a");
  savebtn.setAttribute("class","cms-button action");
  savebtn.setAttribute("id","cms-content-save");
  var savebtntext = document.createTextNode("Save Changes");
  savebtn.appendChild(savebtntext);
  
  var cancelbtn = document.createElement("a");
  cancelbtn.setAttribute("class","cms-button cancel");
  cancelbtn.setAttribute("id","cms-content-cancel");
  var cancelbtntext = document.createTextNode("Cancel");
  cancelbtn.appendChild(cancelbtntext);
  
  buttondiv.appendChild(savebtn);
  buttondiv.appendChild(cancelbtn);
  
  editoverlay.appendChild(h4obj);
  editoverlay.appendChild(pobj);
  editoverlay.appendChild(textareaobj);
  editoverlay.appendChild(hiddenobj);
  editoverlay.appendChild(buttondiv);
  
  document.body.appendChild(editoverlay);
  
  var admin_controls = document.createElement("div");
  admin_controls.setAttribute("id","cms-admin-controls");
  
  var toogle_edit = document.createElement("a");
  toogle_edit.setAttribute("id","cms-admin-controls-toggle");
  toogle_edit.setAttribute("rel","on");
  var toggle_text = document.createTextNode("Hide Live Edit");
  
  toogle_edit.appendChild(toggle_text);
  admin_controls.appendChild(toogle_edit);
  document.body.appendChild(admin_controls);

  CKEDITOR.replace('cms-editor', {
    toolbar: pcms_toolbars["full"],
	height: 400
  });
	
  addCMSEvent(document.getElementById("cms-admin-controls-toggle"), "click", function() {
	if (this.getAttribute("rel") == "on") {
		this.setAttribute("rel","off");
		this.innerHTML = "Show Live Edit";
        var nodeList = document.querySelectorAll(".cke_editable");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			nodeList[i].setAttribute("contenteditable","false");
		}
        var nodeList = document.querySelectorAll(".cms-edit-icon");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			nodeList[i].style.display = "none";
		}
        var nodeList = document.querySelectorAll(".cms-page-overlay");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			nodeList[i].style.display = "none";
		}
        var nodeList = document.querySelectorAll(".cms-content");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			nodeList[i].style.cursor = "default";
		}
		for(k in CKEDITOR.instances){
		  var instance = CKEDITOR.instances[k];
		  var element = instance.element;
		  var contentID = false;
		  if (element.getParent()) contentID = element.getParent();
		  if (contentID) contentID = contentID.getAttribute("id");
		  if (contentID && contentID.indexOf("cms-content-") == 0) {
		    instance.destroy();
		  }
		}
	} else {
		this.setAttribute("rel","on")
		this.innerHTML = "Hide Live Edit";
        var nodeList = document.querySelectorAll(".cms-content");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			var children = nodeList[i].childNodes;
			children[children.length-1].setAttribute("contenteditable","true");
		}
        var nodeList = document.querySelectorAll(".cms-edit-icon");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			nodeList[i].style.display = "block";
		}
        var nodeList = document.querySelectorAll(".cms-content");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			nodeList[i].style.cursor = "pointer";
		}
        var nodeList = document.querySelectorAll(".cms-page-overlay");
        for (var i = 0, length = nodeList.length; i < length; i++) {
			nodeList[i].style.display = "block";
		}
		CKEDITOR.inlineAll();
	}
  });
	
  addCMSEvent(document.getElementById("cms-content-cancel"), "click", function() {
	document.getElementById('overlay-bg').style.display = "none";
	document.getElementById('overlay-cms-content').style.display = "none";
  });
  addCMSEvent(document.getElementById("cms-content-save"), "click", function() {
	var contentID = document.getElementById('cms-content-id').value;
	ajax_update_cms(contentID,CKEDITOR.instances['cms-editor'].getData());
	if (!CKEDITOR.instances['cms-editor'].document) {
		CKEDITOR.instances['cms-editor'].setMode('wysiwyg', function() {
	      document.getElementById('cms-content-'+contentID+'-overlay').nextSibling.innerHTML = CKEDITOR.instances['cms-editor'].document.getBody().getHtml();
	      document.getElementById('overlay-bg').style.display = "none";
	      document.getElementById('overlay-cms-content').style.display = "none";});
    } else {
	      document.getElementById('cms-content-'+contentID+'-overlay').nextSibling.innerHTML = CKEDITOR.instances['cms-editor'].document.getBody().getHtml();
	      document.getElementById('overlay-bg').style.display = "none";
	      document.getElementById('overlay-cms-content').style.display = "none";
    }
  });
  
  var nodeList = document.querySelectorAll(".cms-page-overlay");
  for (var i = 0, length = nodeList.length; i < length; i++) {
     nodeList[i].style.height = nodeList[i].nextSibling.offsetHeight + "px";
     nodeList[i].style.width = nodeList[i].nextSibling.offsetWidth + "px";
	 addCMSEvent(nodeList[i].nextSibling,"mouseover",function() {
		 this.previousSibling.style.opacity = 0.2;
		 this.previousSibling.previousSibling.style.opacity = 0.8;
		 
	 });
	 addCMSEvent(nodeList[i].nextSibling,"mouseout",function() {
		 this.previousSibling.style.opacity = 0;
		 this.previousSibling.previousSibling.style.opacity = 0.5;
	 });
  }
}