<?php
require_once('global.php');
?>
<?php
require_once("wizard.php");
?>
<?php
//default to nothing passed
$_SESSION['serverchecklist'] = array(
	'php' => false,
	'php_notsafemode' => false,
	'gd' => false,
	'filepermissions' => false
);

//php version
$_SESSION['serverchecklist']['php'] = (intval(phpversion()) >= 5);

//safe mode
$_SESSION['serverchecklist']['php_notsafemode'] = (ini_get('safe_mode') && ini_get('safe_mode') != "off") ? false : true;

//gd image library
if(extension_loaded('gd') && function_exists('gd_info')) {
  $_SESSION['serverchecklist']['gd'] = true;
}

//curl
$_SESSION['serverchecklist']['curl'] = false;
$_SESSION['serverchecklist']['curl_wa'] = false;
if(extension_loaded('curl') && function_exists('curl_version')) {
  $_SESSION['serverchecklist']['curl'] = true;
  $c = curl_init();
  curl_setopt($c, CURLOPT_URL, "https://www.webassist.com");
  curl_setopt($c, CURLOPT_TIMEOUT, 90);
  curl_setopt($c, CURLOPT_POST, 1);
  curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
  curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($c, CURLOPT_POSTFIELDS, "");
  $result = curl_exec($c);
  if ($result)  {
    $_SESSION['serverchecklist']['curl_wa'] = true;
  }
}

//file permissions
$ts = time();
$base_dir = '../';
$create_dir = @mkdir($base_dir . 'dir' . $ts);
if($create_dir) $create_dir = @rmdir($base_dir . 'dir' . $ts);
$create_file = @touch($base_dir . 'file' . $ts);
if($create_file) $create_file = @unlink($base_dir . 'file' . $ts);

$_SESSION['serverchecklist']['configwrite'] = true;
if (file_exists($base_dir . "Connections"))  {
  $create_file = @touch($base_dir . "Connections/file" . $ts . ".txt");
  if($create_file) $create_file = @unlink($base_dir . 'Connections/file' . $ts . ".txt");
  $_SESSION['serverchecklist']['configwrite'] = $create_file;   
}

$_SESSION['serverchecklist']['filepermissions'] = ($create_dir && $create_file);

$_SESSION['serverallgood'] = true;
foreach($_SESSION['serverchecklist'] as $check => $value) {
	if(!$value) $_SESSION['serverallgood'] = false;
}

$_SESSION[$installPageID] = $_SESSION['serverallgood'];
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/install.dwt.php" codeOutsideHTMLIsLocked="false" -->
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <!-- InstanceBeginEditable name="doctitle" -->
  <title>Diagnostic - Installation Wizard - <?php echo($installProduct); ?></title>
  <!-- InstanceEndEditable -->
	<style type="text/css" media="all">
  <!--
  @import url("css/install.css");
	@import url("../css/milkbox/milkbox.css");
  -->
    </style>
  <script type="text/javascript" src="../js/mootools-core.js"></script>
  <script type="text/javascript" src="../js/mootools-more.js"></script>
  <script type="text/javascript" src="../js/milkbox-yc.js"></script>
  <!-- InstanceBeginEditable name="head" -->
  <!-- InstanceEndEditable -->
</head>
<body>

<div id="outerWrapper">
	<div id="header">
		
	</div>
	<div id="contentWrapper">
  	<div id="step">
    	<h1>PowerCMS  Installation Wizard</h1>
      <p>Step <strong><?php echo($installPageNum); ?></strong> of <strong><?php echo(sizeof($installPageArray)-1); ?></strong></p>
    </div>
    <div id="content">
      <p class="instructions">
				<!-- InstanceBeginEditable name="instructions" -->
       This Server Diagnostic Check analyzes your server to ensure the necessary permissions and settings are enabled for PowerCMS to work properly.
        <!-- InstanceEndEditable -->
      </p>
      <!-- InstanceBeginEditable name="content" -->
      <form method="post" action="<?php echo($curInstallPage); ?>" name="diagnosticForm">
        <h2>Server Diagnostic Check</h2>
        <?php if(!$_SESSION['serverallgood']) { ?>
        <p class="error"><span>ERROR:</span> All of the attributes below need to check out before you can proceed to the next step.</p>
        <?php } ?>
        <div class="diagnostic diagnostic-<?php echo ($_SESSION['serverchecklist']['php'] && $_SESSION['serverchecklist']['php_notsafemode']) ? 'success' : 'fail'; ?>">
          <h3>PHP <?php echo phpversion(); ?></h3>
          <p>
          	<?php if($_SESSION['serverchecklist']['php'] && $_SESSION['serverchecklist']['php_notsafemode']) { ?>
          	PHP <?php echo phpversion(); ?> is installed.
            <?php } else if(!$_SESSION['serverchecklist']['php_notsafemode']) { ?>
            PHP is running is safe mode. Contact your hosting provider to turn off safe mode.
            <?php } else { ?>
            PHP 5 or greater is required. Contact your hosting provider to upgrade your PHP server.
            <?php } ?>
          </p>
        </div>
        <div class="diagnostic diagnostic-<?php echo $_SESSION['serverchecklist']['gd'] ? 'success' : 'fail'; ?>">
          <h3>GD Image Library</h3>
          <p>
          	<?php if($_SESSION['serverchecklist']['gd']) { ?>
          	GD Image Library [<?php $gdinfo = gd_info(); echo $gdinfo['GD Version']; ?>] is installed.
            <?php } else { ?>
            GD Image Library is not installed. Contact your hosting provider to have GD installed.
            <?php } ?>
					</p>
        </div>
       <div class="diagnostic diagnostic-<?php echo $_SESSION['serverchecklist']['curl'] && $_SESSION['serverchecklist']['curl_wa'] ? 'success' : 'fail'; ?>">
          <h3>cURL</h3>
          <p>
          	<?php if($_SESSION['serverchecklist']['curl']) { ?>
          	cURL [<?php $c = curl_version(); echo $c['version']; ?>] is installed
            <?php if(!$_SESSION['serverchecklist']['curl_wa']) { ?>
            , however cURL was unable to post to the webassist server at https://www.webassist.com.  You will not be able to complete the installation without activating through the webassist web site.
            <?php } ?>.
            <?php } else { ?>
            cURL is not installed. Contact your hosting provider to have cURL installed.
            <?php } ?>
					</p>
        </div>
       
        <div class="diagnostic diagnostic-<?php echo $_SESSION['serverchecklist']['filepermissions'] ? 'success' : 'fail'; ?>">
          <h3>File Permissions</h3>
          <p>
          	<?php if($_SESSION['serverchecklist']['filepermissions']) { ?>
          	Files and directories can be created.
            <?php } else { ?>
            Files and directories cannot be created. Verify the <strong><?php echo($base_dir); ?></strong> 
            directory has write permissions on your server.
            <?php if (!$_SESSION['serverchecklist']['configwrite'])  { ?>
            <br />Please make sure the <?php echo($base_dir. "Connections"); ?> folder has write permissions on your server.
            <?php } ?>
            <?php } ?>
          </p>
        </div>
        <div class="buttons">
        	<?php if($_SESSION['serverallgood']) { ?>
          <a href="database.php"><img alt="Get Started" src="images/btn_next.png" /></a>
          <?php } else { ?>
          <a href="diagnostic.php"><img alt="Get Started" src="images/btn_runcheckagain.png" /></a>
          <?php } ?>
        </div>
      </form>
      <!-- InstanceEndEditable -->
    </div>
  </div>
  <div id="contentWrapperCap"></div>
</div>

</body>
<!-- InstanceEnd --></html>