
CREATE TABLE `pcms2_contenthistory` (
  `HistoryID` int(11) NOT NULL auto_increment,
  `HistoryContentID` int(11) default NULL,
  `HistoryUserID` int(11) default NULL,
  `HistoryValue` text,
  `HistoryGroup` varchar(100) default NULL,
  `HistoryReference` varchar(100) default NULL,
  `HistoryDate` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `ContentPageName` varchar(100) default NULL,
  `ContentPageSetParentID` int(11) default NULL,
  `ContentPageSetOrder` int(11) default NULL,
  `ParentID` int(11) default NULL,
  PRIMARY KEY  (`HistoryID`)
);

CREATE TABLE `pcms2_contents` (
  `ContentID` int(11) NOT NULL AUTO_INCREMENT,
  `ContentGroup` varchar(100) DEFAULT NULL,
  `ContentRefID` varchar(100) DEFAULT NULL,
  `ContentUserID` int(11) DEFAULT NULL,
  `ContentValue` text,
  `ContentDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `ContentPageName` varchar(100) DEFAULT NULL,
  `ContentPageSetParentID` int(11) DEFAULT NULL,
  `ContentPageSetOrder` int(11) DEFAULT NULL,
  `ParentID` int(11) DEFAULT NULL,
  `ContentAdminToolbar` varchar(50) DEFAULT NULL,
  `ContentInlineToolbar` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`ContentID`)
);

CREATE TABLE IF NOT EXISTS wa_settings (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) COLLATE latin1_bin DEFAULT NULL,
  `type` varchar(50) COLLATE latin1_bin DEFAULT NULL,
  `options` text COLLATE latin1_bin,
  `value` varchar(255) COLLATE latin1_bin DEFAULT NULL,
  `grp` varchar(50) COLLATE latin1_bin DEFAULT NULL,
  `subcategory` varchar(50) COLLATE latin1_bin DEFAULT NULL,
  `cond` varchar(255) COLLATE latin1_bin DEFAULT NULL,
  `description` varchar(255) COLLATE latin1_bin DEFAULT NULL,
  `variable` varchar(50) COLLATE latin1_bin DEFAULT NULL,
  `weight` float DEFAULT NULL,
  `spry_args` text COLLATE latin1_bin,
  `spry_error` text COLLATE latin1_bin,
  `help_text` text COLLATE latin1_bin,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_bin;

INSERT INTO `wa_settings` (`name`,`type`,`options`,`value`,`grp`,`subcategory`,`cond`,`description`,`variable`,`weight`,`spry_args`,`spry_error`,`help_text`)
VALUES
	('Site Name', NULL, NULL, 'My Site', NULL, NULL, NULL, NULL,'Site_Name', NULL, NULL, NULL, NULL),
	('Serial Number', NULL, NULL, '@@serial_number@@', NULL, NULL, NULL, NULL,'PCMS_Serial', NULL, NULL, NULL, NULL),
	('Image Upload Folder', NULL, NULL, 'files', NULL, NULL, NULL, NULL, 'images_folder', NULL, NULL, NULL, NULL),
	('Disable Images Upload', NULL, NULL, 0, NULL, NULL, NULL, NULL, 'dis_images_upload', NULL, NULL, NULL, NULL);

CREATE TABLE `pcms2_usergroups` (
  `UserGroupID` int(11) NOT NULL auto_increment,
  `UserGroup` varchar(50) default NULL,
  PRIMARY KEY  (`UserGroupID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

insert  into `pcms2_usergroups`(`UserGroupID`,`UserGroup`) values (1,'Administrator');

CREATE TABLE `pcms2_users` (
  `UserID` int(11) NOT NULL auto_increment,
  `UserEmail` varchar(500) default NULL,
  `UserPassword` varchar(500) default NULL,
  `UserFirstName` varchar(50) default NULL,
  `UserLastName` varchar(50) default NULL,
  `UserCity` varchar(90) default NULL,
  `UserState` varchar(20) default NULL,
  `UserZip` varchar(12) default NULL,
  `UserEmailVerified` tinyint(1) default '0',
  `UserRegistrationDate` timestamp NULL default CURRENT_TIMESTAMP,
  `UserVerificationCode` varchar(20) default NULL,
  `UserIP` varchar(50) default NULL,
  `UserPhone` varchar(20) default NULL,
  `UserFax` varchar(20) default NULL,
  `UserCountry` varchar(20) default NULL,
  `UserAddress` varchar(100) default NULL,
  `UserAddress2` varchar(50) default NULL,
  `UserGroupID` int(11) NOT NULL default '1',
  PRIMARY KEY  (`UserID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `pcms2_toolbardefinitions` (
  `ToolbarDefinitionID` int(11) NOT NULL AUTO_INCREMENT,
  `ToolbarDefinitionToolbar` int(11) NOT NULL,
  `ToolbarDefinitionGroup` int(11) NOT NULL,
  `ToolbarDefinitionOrder` int(11) NOT NULL,
  PRIMARY KEY (`ToolbarDefinitionID`)
) ENGINE=MyISAM AUTO_INCREMENT=39 DEFAULT CHARSET=latin1;

INSERT INTO `pcms2_toolbardefinitions` VALUES 
  ('1', '1', '1', '1'),
  ('2', '1', '2', '2'),
  ('3', '1', '3', '3'),
  ('4', '1', '4', '4'),
  ('5', '1', '0', '5'),
  ('6', '1', '5', '6'),
  ('7', '1', '6', '7'),
  ('8', '1', '7', '8'),
  ('9', '1', '8', '9'),
  ('10', '1', '0', '10'),
  ('11', '1', '9', '11'),
  ('12', '1', '10', '12'),
  ('13', '1', '11', '13'),
  ('14', '2', '12', '1'),
  ('15', '3', '13', '1'),
  ('16', '3', '14', '2'),
  ('17', '3', '19', '3'),
  ('18', '3', '6', '4'),
  ('19', '3', '20', '5'),
  ('20', '3', '7', '6'),
  ('21', '3', '15', '7'),
  ('22', '3', '16', '8'),
  ('23', '3', '10', '9'),
  ('24', '3', '19', '10'),
  ('25', '4', '21', '1'),
  ('26', '4', '13', '2'),
  ('27', '4', '14', '3'),
  ('28', '4', '8', '13'),
  ('29', '4', '0', '5'),
  ('30', '4', '6', '6'),
  ('32', '4', '7', '4'),
  ('33', '4', '0', '9'),
  ('34', '4', '16', '10'),
  ('35', '4', '10', '11'),
  ('36', '4', '17', '12'),
  ('37', '3', '18', '11'),
  ('38', '4', '5', '8');

CREATE TABLE `pcms2_toolbargroupdefinitions` (
  `GroupDefinitionID` int(11) NOT NULL AUTO_INCREMENT,
  `GroupDefinitionGroup` int(11) NOT NULL,
  `GroupDefinitionOption` int(11) NOT NULL,
  `GroupDefinitionOrder` int(11) NOT NULL,
  PRIMARY KEY (`GroupDefinitionID`)
) ENGINE=MyISAM AUTO_INCREMENT=133 DEFAULT CHARSET=latin1;

INSERT INTO `pcms2_toolbargroupdefinitions` VALUES 
  ('1', '1', '1', '1'),
  ('2', '1', '0', '2'),
  ('3', '1', '2', '3'),
  ('4', '1', '3', '4'),
  ('5', '1', '4', '5'),
  ('6', '1', '5', '6'),
  ('7', '1', '6', '7'),
  ('8', '1', '0', '8'),
  ('9', '1', '7', '9'),
  ('10', '2', '8', '1'),
  ('11', '2', '9', '2'),
  ('12', '2', '10', '3'),
  ('13', '2', '11', '4'),
  ('14', '2', '12', '5'),
  ('15', '2', '0', '6'),
  ('16', '2', '13', '7'),
  ('17', '2', '14', '8'),
  ('18', '3', '15', '1'),
  ('19', '3', '16', '2'),
  ('20', '3', '0', '3'),
  ('21', '3', '17', '4'),
  ('22', '3', '0', '5'),
  ('23', '3', '18', '6'),
  ('24', '3', '19', '7'),
  ('25', '4', '20', '1'),
  ('26', '4', '21', '2'),
  ('27', '4', '22', '3'),
  ('28', '4', '23', '4'),
  ('29', '4', '24', '5'),
  ('30', '4', '25', '6'),
  ('31', '4', '26', '7'),
  ('32', '4', '27', '8'),
  ('33', '4', '28', '9'),
  ('34', '5', '29', '1'),
  ('35', '5', '30', '2'),
  ('36', '5', '31', '3'),
  ('37', '5', '32', '4'),
  ('38', '5', '33', '5'),
  ('39', '5', '34', '6'),
  ('40', '5', '0', '7'),
  ('41', '5', '35', '8'),
  ('42', '6', '36', '1'),
  ('43', '6', '37', '2'),
  ('44', '6', '0', '3'),
  ('45', '6', '38', '4'),
  ('46', '6', '39', '5'),
  ('47', '6', '0', '6'),
  ('48', '6', '40', '7'),
  ('49', '6', '41', '8'),
  ('50', '6', '0', '9'),
  ('51', '6', '42', '10'),
  ('52', '6', '43', '11'),
  ('53', '6', '44', '12'),
  ('54', '6', '45', '13'),
  ('55', '6', '0', '14'),
  ('56', '6', '46', '15'),
  ('57', '6', '47', '16'),
  ('58', '7', '48', '1'),
  ('59', '7', '49', '2'),
  ('60', '7', '50', '3'),
  ('61', '8', '51', '1'),
  ('62', '8', '52', '2'),
  ('63', '8', '53', '3'),
  ('64', '8', '54', '4'),
  ('65', '8', '55', '5'),
  ('66', '8', '56', '6'),
  ('67', '8', '57', '7'),
  ('68', '8', '58', '8'),
  ('69', '9', '59', '1'),
  ('70', '9', '60', '2'),
  ('71', '9', '61', '3'),
  ('72', '9', '62', '4'),
  ('73', '10', '63', '1'),
  ('74', '10', '64', '2'),
  ('75', '11', '65', '1'),
  ('76', '11', '66', '2'),
  ('88', '11', '67', '4'),
  ('87', '11', '0', '3'),
  ('77', '12', '29', '1'),
  ('78', '12', '30', '2'),
  ('79', '12', '0', '3'),
  ('80', '12', '36', '4'),
  ('81', '12', '37', '5'),
  ('82', '12', '0', '6'),
  ('83', '12', '48', '7'),
  ('84', '12', '49', '8'),
  ('89', '13', '8', '1'),
  ('90', '13', '9', '2'),
  ('91', '13', '10', '3'),
  ('92', '13', '11', '4'),
  ('93', '13', '12', '5'),
  ('94', '13', '0', '6'),
  ('95', '13', '18', '7'),
  ('96', '13', '19', '8'),
  ('97', '14', '13', '1'),
  ('98', '14', '14', '2'),
  ('99', '14', '0', '3'),
  ('100', '14', '15', '4'),
  ('101', '14', '16', '5'),
  ('102', '14', '0', '6'),
  ('103', '14', '17', '7'),
  ('104', '14', '35', '8'),
  ('105', '15', '51', '1'),
  ('106', '15', '52', '2'),
  ('107', '15', '53', '3'),
  ('108', '15', '54', '4'),
  ('109', '15', '56', '5'),
  ('110', '16', '60', '1'),
  ('111', '16', '61', '2'),
  ('112', '16', '62', '3'),
  ('113', '17', '65', '1'),
  ('114', '17', '66', '2'),
  ('115', '18', '66', '1'),
  ('116', '18', '0', '2'),
  ('117', '18', '69', '3'),
  ('118', '19', '29', '1'),
  ('119', '19', '30', '2'),
  ('120', '19', '31', '3'),
  ('121', '19', '32', '4'),
  ('122', '19', '0', '5'),
  ('123', '19', '33', '6'),
  ('124', '19', '34', '7'),
  ('126', '20', '42', '1'),
  ('127', '20', '43', '2'),
  ('128', '20', '44', '3'),
  ('129', '20', '45', '4'),
  ('130', '21', '1', '1'),
  ('131', '21', '0', '2'),
  ('132', '21', '5', '3');

CREATE TABLE `pcms2_toolbargroups` (
  `ToolbarGroupID` int(11) NOT NULL AUTO_INCREMENT,
  `ToolbarGroupName` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`ToolbarGroupID`)
) ENGINE=MyISAM AUTO_INCREMENT=22 DEFAULT CHARSET=latin1;

INSERT INTO `pcms2_toolbargroups` VALUES 
  ('1', 'document'),
  ('2', 'clipboard'),
  ('3', 'editing'),
  ('4', 'forms'),
  ('5', 'basicstyles'),
  ('6', 'paragraph'),
  ('7', 'links'),
  ('8', 'insert'),
  ('9', 'styles'),
  ('10', 'colors'),
  ('11', 'tools'),
  ('12', 'basic'),
  ('13', 'inline clipboard'),
  ('14', 'inline editing'),
  ('15', 'stripped insert'),
  ('16', 'format'),
  ('17', 'stripped tools'),
  ('18', 'inline tools'),
  ('19', 'inline styles'),
  ('20', 'justify'),
  ('21', 'source');

CREATE TABLE `pcms2_toolbaroptions` (
  `ToolbarOptionID` int(11) NOT NULL AUTO_INCREMENT,
  `ToolbarOptionName` varchar(50) DEFAULT NULL,
  `ToolbarOptionDescription` varchar(1000) DEFAULT NULL,
  PRIMARY KEY (`ToolbarOptionID`)
) ENGINE=MyISAM AUTO_INCREMENT=70 DEFAULT CHARSET=latin1;

INSERT INTO `pcms2_toolbaroptions` VALUES 
  ('1', 'Source', null),
  ('2', 'Save', null),
  ('3', 'NewPage', null),
  ('4', 'DocProps', null),
  ('5', 'Preview', null),
  ('6', 'Print', null),
  ('7', 'Templates', null),
  ('8', 'Cut', null),
  ('9', 'Copy', null),
  ('10', 'Paste', null),
  ('11', 'PasteText', null),
  ('12', 'PasteFromWord', null),
  ('13', 'Undo', null),
  ('14', 'Redo', null),
  ('15', 'Find', null),
  ('16', 'Replace', null),
  ('17', 'SelectAll', null),
  ('18', 'SpellChecker', null),
  ('19', 'Scayt', null),
  ('20', 'Form', null),
  ('21', 'Checkbox', null),
  ('22', 'Radio', null),
  ('23', 'TextField', null),
  ('24', 'Textarea', null),
  ('25', 'Select', null),
  ('26', 'Button', null),
  ('27', 'ImageButton', null),
  ('28', 'HiddenField', null),
  ('29', 'Bold', null),
  ('30', 'Italic', null),
  ('31', 'Underline', null),
  ('32', 'Strike', null),
  ('33', 'Subscript', null),
  ('34', 'Superscript', null),
  ('35', 'RemoveFormat', null),
  ('36', 'NumberedList', null),
  ('37', 'BulletedList', null),
  ('38', 'Outdent', null),
  ('39', 'Indent', null),
  ('40', 'Blockquote', null),
  ('41', 'CreateDiv', null),
  ('42', 'JustifyLeft', null),
  ('43', 'JustifyCenter', null),
  ('44', 'JustifyRight', null),
  ('45', 'JustifyBlock', null),
  ('46', 'BidiLtr', null),
  ('47', 'BidiRtl', null),
  ('48', 'Link', null),
  ('49', 'Unlink', null),
  ('50', 'Anchor', null),
  ('51', 'Image', null),
  ('52', 'Flash', null),
  ('53', 'Table', null),
  ('54', 'HorizontalRule', null),
  ('55', 'Smiley', null),
  ('56', 'SpecialChar', null),
  ('57', 'PageBreak', null),
  ('58', 'Iframe', null),
  ('59', 'Styles', null),
  ('60', 'Format', null),
  ('61', 'Font', null),
  ('62', 'FontSize', null),
  ('63', 'TextColor', null),
  ('64', 'BGColor', null),
  ('65', 'Maximize', null),
  ('66', 'ShowBlocks', null),
  ('67', 'About', null),
  ('69', 'Cms_source', null);

CREATE TABLE `pcms2_toolbarpresets` (
  `ToolbarID` int(11) NOT NULL AUTO_INCREMENT,
  `ToolbarName` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`ToolbarID`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

INSERT INTO `pcms2_toolbarpresets` VALUES 
  ('1', 'full'),
  ('2', 'basic'),
  ('3', 'inline default'),
  ('4', 'default'),
  ('5', 'none');